// ========================================================
//
// 3402_D_Husky_LineFollower
// 28-01-23
//
// ========================================================

#include <CBPFBO_StepperA.h>
#include "HUSKYLENS.h"
#include "SoftwareSerial.h"

#define DEBUG true 

#define wheelDia 49.9
#define axleLen 98.0

HUSKYLENS husky;

int x0;

void setup(){
  Serial.begin(9600); 
  setRobotParams(wheelDia,axleLen);
  Wire.begin();

  while( !husky.begin(Wire)){
    Serial.println("Check General Seetings >> Protocol Type >> I2C");
    Serial.println("Husky Configured");
    delay(100);
  }
  Serial.println("Husky Configured");
  husky.writeAlgorithm(ALGORITHM_LINE_TRACKING);
}


void loop() {

 if( !husky.request()) 
   cprintf("Recheck Connexions\n");
   
 if(husky.available()){
    HUSKYLENSResult result = husky.read();
    x0 = result.xOrigin;
    float error = getErrorX();
    moveABit(error,0.5);
    cprintf("Error = %f\n",error);
 }
                        
}

float getErrorX() {
  float error;
  error = (float)x0 - 160,
  error = -error/160;
  return error;
}
