// ========================================================
// BBDrive_Proc_1a
// CBP 03-10-23
// Procedural Braitenberg
// Linear Interpolation
// Measures eye readings (no exp fn)
// ========================================================

#include <Servo.h>

// Pin defines
#define LDR_L A0
#define LDR_R A1

#define BUFLEN 10 // For averaging
#define ServoL_pin 13
#define ServoR_pin 12


// --------------------------------------

float bufferL[BUFLEN];
float bufferR[BUFLEN];
float avL;
float avR;
float inL, inR;

// Motor stuff --------------
Servo servoL;
Servo servoR;
float driveL, driveR;
float maxDrive = 60;

void calcAverage() {
  bufferL[0] = inL;
  bufferR[0] = inR;

  avL = 0;
  avR = 0;

  for (int i = 0; i < BUFLEN; i++) {
    avL += bufferL[i];
    avR += bufferR[i];
  }
  avL = avL / BUFLEN;
  avR = avR / BUFLEN;

  for (int i = BUFLEN - 1; i > 0; i--) {
    bufferL[i] = bufferL[i - 1];
    bufferR[i] = bufferR[i - 1];
  }

}

void setup() { // --------------------------------------
  
  delay(2000);
  Serial.begin(9600);

  servoL.attach(ServoL_pin);
  servoR.attach(ServoR_pin);

} // ----------------------------------------------------

void loop() { // ----------------------------------------

  inL = (float)analogRead(LDR_L);
  inR = (float)analogRead(LDR_R);

  calcAverage();

  cprintf("avL = %f, avR = %f\n",avL,avR);

} // ----------------------------------------------------
