// ========================================================
// BBDrive_R_Proc_1b
// CBP 03-10-23
// Procedural Braitenberg
// Linear Interpolation
// Ramps motor speed to test. All proessing in setup()
// ========================================================

#include <Servo.h>

// Pin defines
#define LDR_L A0
#define LDR_R A1
#define LED_PIN 4

#define BUFLEN 10 // For averaging

#define ServoL_pin 13
#define ServoR_pin 12

// --------------------------------------


float bufferL[BUFLEN];
float bufferR[BUFLEN];
float avL;
float avR;
float inL, inR;

unsigned long startTime, duration;
int state;

// Motor stuff --------------
Servo servoL;
Servo servoR;
float driveL, driveR;

void setup() { // --------------------------------------
  
  delay(5000);
  Serial.begin(9600);

  pinMode(LED_PIN,OUTPUT);
  digitalWrite(LED_PIN,LOW);
  
  servoL.attach(ServoL_pin);
  servoR.attach(ServoR_pin);

  // Increment the motor drive 0 to 90
  for(int i = 0; i < 10; i++) {
    flashLED();
    driveL = 10*i;
    driveR = 10*i;
    driveServos(driveL,driveR);
    delay(3000);
  }

  // stop the motors
  driveServos(0.0,0.0);

} // --------------------------------------------------

void loop() { // --------------------------------------


} // --------------------------------------------------

void flashLED() {
  digitalWrite(LED_PIN,HIGH);
  delay(1000);
  digitalWrite(LED_PIN,LOW);
}

void driveServos(float _driveL, float _driveR) {
  _driveR = _driveR*0.8;
  servoL.writeMicroseconds(1500 + (int)_driveL);
  servoR.writeMicroseconds(1500 - (int)_driveR);
}
