// ========================================================
// BBDrive_R_Proc_1c
// CBP 03-10-23
// Procedural Braitenberg Vehicle 2b
// Linear Interpolation
// Status: Release
// ========================================================

#include <Servo.h>

// Pin defines
#define LDR_L A0
#define LDR_R A1
#define LED_PIN 4

#define ServoL_pin 13
#define ServoR_pin 12

// Motor stuff --------------
Servo servoL;
Servo servoR;
float driveL, driveR;
// put your drive low and high values here
float driveLow = 
float driveHigh = 

// Eye stuff ----------------
// Put your eye low and high values here
float eyeLow = 
float eyeHigh = 
float eyeL, eyeR;

// Interpolator inputs ------
float interpInL;
float interpInR;

void setup() { // --------------------------------------
  
  delay(2000);
  Serial.begin(9600);

  pinMode(LED_PIN,OUTPUT);
  digitalWrite(LED_PIN,LOW);
  
  servoL.attach(ServoL_pin);
  servoR.attach(ServoR_pin);

} // ----------------------------------------------------

void loop() { // ----------------------------------------

  eyeL = (float)analogRead(LDR_L);
  eyeR = (float)analogRead(LDR_R);

  // make the eye-motor connexions here
  interpInL = 
  interpInR = 
  
  driveL = interpolate(interpInL,eyeLow,eyeHigh,driveLow,driveHigh);
  driveR = interpolate(interpInR,eyeLow,eyeHigh,driveLow,driveHigh);

  driveServos(driveL,driveR);

  cprintf("eyeL = %f, eyeR = %f, driveL = %f, driveR = %f\n",eyeL,eyeR,driveL,driveR);
  
} // ----------------------------------------------------

float interpolate(float _eyeInput,
                  float _eyeLow,
                  float _eyeHigh,
                  float _driveLow,
                  float _driveHigh){

  float driveOutput;

  // constrain inputs within allowed range
  if(_eyeInput < _eyeLow) _eyeInput = _eyeLow;
  if(_eyeInput > _eyeHigh) _eyeInput = _eyeHigh;
  
  driveOutput = _driveLow + (_eyeInput - _eyeLow)*(_driveHigh - _driveLow)/(_eyeHigh - _eyeLow);

  return driveOutput;
}

void driveServos(float _driveL, float _driveR) {
  _driveR = _driveR*0.8;
  servoL.writeMicroseconds(1500 + (int)_driveL);
  servoR.writeMicroseconds(1500 - (int)_driveR);
}
