// ========================================================
//
// CBP_2403_R_EncoderTest_1
// CBP 31-07-23, 29-08-23
// Count encoder pulses, rotate wheels by hand
// Status Release
//
// ========================================================

#include <stdio.h>
#include <Servo.h>

// Define pins ---------------
#define ServoL_pin 13
#define ServoR_pin 12
#define EncoderL_pin 3
#define EncoderR_pin 2
#define LED_Red_pin 4
#define LED_Yel_pin 5

// Define constants ----------
#define DEBUG true
#define wheelDiam 66.0
#define wheelRad (wheelDiam/2.0)
#define axleLen 104.0

// Global variables ----------
Servo servoL;
Servo servoR; 
float driveL, driveR;

volatile int countL = 0;
volatile int countR = 0;

void setup() {
  cprintf(">>> Initializing stuff ..................\n");
  Serial.begin(9600);
  pinMode(10,INPUT);
  pinMode(2,INPUT);
  pinMode(11,INPUT);

  attachInterrupt(digitalPinToInterrupt(EncoderL_pin),ISR_Left,RISING);
  attachInterrupt(digitalPinToInterrupt(EncoderR_pin),ISR_Right,RISING);  

}

void loop() {
  cprintf("CountL = %d, countR = %d\n",countL,countR);
  delay(100);
}

void ISR_Left() {
  countL++;
}

void ISR_Right() {
  countR++;
}
