// ========================================================
//
// CBP_2403_R_EncoderTest_2
// CBP 29-08-23
// Count encoder pulses.  Drives N wheel rotations.
// Status Release
//
// ========================================================

#include <stdio.h>
#include <Servo.h>

// Define pins ---------------
#define ServoL_pin 13
#define ServoR_pin 12
#define EncoderL_pin 3
#define EncoderR_pin 2
#define LED_Red_pin 4
#define LED_Yel_pin 5

// Define constants ----------
#define DEBUG true
#define wheelDiam 66.0
#define wheelRad (wheelDiam/2.0)
#define axleLen 104.0

// Global variables ----------
Servo servoL;
Servo servoR; 

volatile int countL = 0;
volatile int countR = 0;

float driveL = 0.0;
float driveR = 0.0;

int nL = 0;
int nR = 0;
int nrRevs = 0;

void setup() {
  Serial.begin(9600);

  cprintf(">>> Initializing stuff ..................\n");
  pinMode(10,INPUT);
  pinMode(2,INPUT);
  pinMode(11,INPUT);
  servoL.attach(ServoL_pin);
  servoR.attach(ServoR_pin);
  attachInterrupt(digitalPinToInterrupt(EncoderL_pin),ISR_Left,CHANGE);
  attachInterrupt(digitalPinToInterrupt(EncoderR_pin),ISR_Right,CHANGE);  

  // Servo Drive 
  driveL = 40;
  driveR = 40;

  countL = 0;
  countR = 0;

  // counts for 1 revolution of each wheel
  nL = 64;
  nR = 64;

  // counts for nrRevs revolutions


  delay(2000);
  cprintf(">>> Entering loop() .................\n");
}

void loop() {

  while( (countL < nL) && (countR < nR) ){
      driveServos(driveL,driveR);
      delay(200);
      if(DEBUG) cprintf("CountL = %d, countR = %d\n", countL,countR);
  }
  driveServos(0,0);
  //servoL.detach();
  //servoR.detach();
  
}

void ISR_Left() {
  countL++;
}

void ISR_Right() {
  countR++;
}

void driveServos(float _driveL, float _driveR) {
  servoL.writeMicroseconds(1500 + (int)_driveL);
  servoR.writeMicroseconds(1500 - (int)_driveR);
}
