// ========================================================
//
// CBP_2403_R_EncoderTest_2a
// CBP 30-08-23
// Calc nL nR for desired distance
// Status Release
//
// ========================================================

#include <stdio.h>
#include <Servo.h>

// Define pins ---------------
#define ServoL_pin 13
#define ServoR_pin 12
#define EncoderL_pin 3
#define EncoderR_pin 2
#define LED_Red_pin 4
#define LED_Yel_pin 5

// Define constants ----------
#define DEBUG true
#define wheelDiam 66.0
#define wheelRad (wheelDiam/2.0)
#define axleLen 104.0
#define dx (wheelRad*2*PI/64)

// Global variables ----------
Servo servoL;
Servo servoR; 

volatile unsigned long countL = 0;
volatile unsigned long countR = 0;

float driveL = 0.0;
float driveR = 0.0;

unsigned long nL = 0;
unsigned long nR = 0;

float desiredDist;

void setup() {
  Serial.begin(9600);

  cprintf(">>> Initializing stuff ..................\n");
  pinMode(10,INPUT);
  pinMode(2,INPUT);
  pinMode(11,INPUT);
  servoL.attach(ServoL_pin);
  servoR.attach(ServoR_pin);
  attachInterrupt(digitalPinToInterrupt(EncoderL_pin),ISR_Left,CHANGE);
  attachInterrupt(digitalPinToInterrupt(EncoderR_pin),ISR_Right,CHANGE);  

  // Set servo drive
  driveL = 40;
  driveR = 40;

  countL = 0;
  countR = 0;

  // Set desired distance (mm);
  //desiredDist = 
  
  // Calc counts for desired distance
  //nL = 
  nR = nL;

  cprintf("Calculated steps: nL = nR = %l",nL);

  delay(2000);
  cprintf(">>> Entering loop() .................\n");
}

void loop() {

  while( (countL < nL) && (countR < nR) ){
      driveServos(driveL,driveR);
      delay(200);
      if(DEBUG) cprintf("CountL = %d, countR = %d\n", countL,countR);
  }
  driveServos(0,0);
  //servoL.detach();
  //servoR.detach();
  
}

void ISR_Left() {
  countL++;
}

void ISR_Right() {
  countR++;
}

void driveServos(float _driveL, float _driveR) {
  servoL.writeMicroseconds(1500 + (int)_driveL);
  servoR.writeMicroseconds(1500 - (int)_driveR);
}
