// ========================================================
// CBP_2403_D_JunctionReact_1
// 19-08-23
// From FBO 20-08-21
// 20-08-23 : (i) added adaptive juncAdvance acc to where
// pixycam detects the junction. (ii) corrected axleLen to
// get 90deg pivot. (iii) added LEDs indicator of states
// ========================================================

#include <CBPFBO_StepperA.h>
#define DEBUG false  

#define STATE_EXPLORE 1
#define STATE_LEFT_TURN 2
#define STATE_RIGHT_TURN 3
#define STATE_ABOUT_FACE 4
int state;

// This is the main Pixy object 
Pixy2 pixy;

float error;
float gain;

uint8_t x0;
uint8_t y0;
uint8_t y1;
uint16_t juncAdvance;
uint16_t vMax;
int junctionID;
float axleLen = 100.0;

void setup(){
  Serial.begin(9600);                       
  gain = 1.0;  

  pinMode(14,OUTPUT);
  pinMode(16,OUTPUT);
  pinMode(18,OUTPUT);
   
  state = STATE_EXPLORE;

  pixy.init();
  // Change to line tracking program
  pixy.changeProg("line");

  axleLen = axleLen * 90 /99.0;
  setRobotParams(47.25,axleLen);
  
  juncAdvance = 157.5;
  vMax = 18;
  pixy.setLamp(1,1);
}

void loop() {

  int advance;
  pixy.line.getAllFeatures();

  x0 = pixy.line.vectors[0].m_x0;
  y0 = pixy.line.vectors[0].m_y0;
  y1 = pixy.line.vectors[0].m_y1;

  advance = (int)((float)y1*1.19);
  
  switch(state) {
    case STATE_EXPLORE:

    // Get the error and use moveABit(...)
    
    // Test for each junction type. If valid junctions are
    // found, then advance onto the junction, then transit
    // to the next appropriate state.

      break; // end of this state
      
    case STATE_LEFT_TURN:
    // Do a pivot, then goto the next state
      break;

    // Add more cases for other states

  } // end of switch

  if(state == STATE_EXPLORE) {
    doLEDS(1,0,0);
  }
  if(state == STATE_RIGHT_TURN) {
    doLEDS(0,1,0);
  }
  if(state == STATE_LEFT_TURN) {
    doLEDS(0,0,1);
  } 
  if(state == STATE_ABOUT_FACE) {
    doLEDS(0,1,1);
  } 
                        
} // end of loop

void reportJunction(int junctionID){
  
  if(junctionID == 2) {
    cprintf("LEFT\n");
    doLEDS(0,0,1);
  }
  else if (junctionID == 4){
    cprintf("RIGHT\n");   
    doLEDS(0,1,0);
  }
  else if (junctionID ==1) {
    cprintf("TEE\n");
    doLEDS(0,1,1);
  }
  else {
    cprintf("NONE\n");
    doLEDS(0,0,0);
  }
}
void doLEDS(int red, int yell, int grn) {
  if(red == 1) digitalWrite(14,HIGH);
  else digitalWrite(14,LOW);
  if(yell == 1) digitalWrite(16,HIGH);
  else digitalWrite(16,LOW);
  if(grn == 1) digitalWrite(18,HIGH);
  else digitalWrite(18,LOW);  
}

int junctionSearch(Pixy2 pixy) {

  int junctionNumber = 0;
  int angleDetected;
  
  int16_t angs[3];
    for(int i = 0; i < 3; i++) {
       angs[i] = pixy.line.intersections[0].m_intLines[i].m_angle;
    }

    junctionNumber = detectCorners(angs);

  return junctionNumber;
}

float getErrorX() {
  float error;
  error = x0 - 40;
  error = error / 40;
  return error; 
}
