// ========================================================
// CBP_2403_R_JunctionReact_1a
// 07-11-23
// From CBP_2403_D_JunctionReact_1
// From FBO 20-08-21
// Status: release
// ========================================================

#include <CBPFBO_StepperA.h>
#define DEBUG false  
 
Pixy2 pixy;

float error;
float gain;

uint8_t x0;
uint8_t y0;
uint8_t y1;
uint16_t juncAdvance;
uint16_t vMax;
int junctionID;
float axleLen = 100.0;

void setup(){
  Serial.begin(9600);                       
  gain = 1.0;  

  pinMode(14,OUTPUT);
  pinMode(16,OUTPUT);
  pinMode(18,OUTPUT);

  pixy.init();
  // Change to line tracking program
  pixy.changeProg("line");

  axleLen = axleLen * 90 /99.0;
  setRobotParams(47.25,axleLen);
  
  juncAdvance = 157.5;
  vMax = 18;
  pixy.setLamp(1,1);
}

void loop() {

  int advance;
  pixy.line.getAllFeatures();

  x0 = pixy.line.vectors[0].m_x0;
  y0 = pixy.line.vectors[0].m_y0;
  y1 = pixy.line.vectors[0].m_y1;

  advance = (int)((float)y1*1.19);

  cprintf("advance = %d\n",advance);
  
  junctionID = junctionSearch(pixy);

  reportJunction(junctionID);

  // Add code here to advance to get wheels on junction line
  // if there is a valid junction
  


  delay(1000);

  // Add code to pivot in the correct direction (angle) if
  // there is a valid junction
  
  
  delay(1000);
                 
}

void reportJunction(int junctionID){
  
  if(junctionID == 2) {
    cprintf("LEFT\n");
    doLEDS(0,0,1);
  }
  else if (junctionID == 4){
    cprintf("RIGHT\n");   
    doLEDS(0,1,0);
  }
  else if (junctionID ==1) {
    cprintf("TEE\n");
    doLEDS(0,1,1);
  }
  else {
    cprintf("NONE\n");
    doLEDS(0,0,0);
  }
}
void doLEDS(int red, int yell, int grn) {
  if(red == 1) digitalWrite(14,HIGH);
  else digitalWrite(14,LOW);
  if(yell == 1) digitalWrite(16,HIGH);
  else digitalWrite(16,LOW);
  if(grn == 1) digitalWrite(18,HIGH);
  else digitalWrite(18,LOW);  
}

int junctionSearch(Pixy2 pixy) {

  int junctionNumber = 0;
  int angleDetected;
  
  int16_t angs[3];
    for(int i = 0; i < 3; i++) {
       angs[i] = pixy.line.intersections[0].m_intLines[i].m_angle;
    }

    junctionNumber = detectCorners(angs);

  return junctionNumber;
}

float getErrorX() {
  float error;
  error = x0 - 40;
  error = error / 40;
  return error; 
}
