// ========================================================
// CBP_2403_R_Junction_Test_2
// Test Pixy2 junctions
// Based on FBO and CBP 18-06-21
// 20-08-21
// ========================================================

#include "CBPFBO_StepperA.h"

// This is the main Pixy object 
Pixy2 pixy;


void setup(){

  pixy.init();
  // Change to line tracking program
  pixy.changeProg("line");

  Serial.begin(9600);    

  pinMode(14,OUTPUT);
  pinMode(16,OUTPUT);
  pinMode(18,OUTPUT);
}

void loop() {
  
  int result =  pixy.line.getAllFeatures();
  if(result < 0) cprintf("PIXYCAM ERROR\n");
  int16_t angs[3];
  int16_t junctionID;

  int nrIntersect =pixy.line.numIntersections;
  cprintf("nrIntersections = %d ",nrIntersect);
   
  for(int i = 0; i < 3; i++) {
    angs[i] = pixy.line.intersections[0].m_intLines[i].m_angle;
    cprintf("Angs[%d] = %d, ",i,angs[i]);
  }

  junctionID = detectCorners(angs);

  if(junctionID == 2) {
    cprintf("LEFT\n");
    doLEDS(0,0,1);
  }
  else if (junctionID == 4){
    cprintf("RIGHT\n");   
    doLEDS(0,1,0);
  }
  else if (junctionID ==1) {
    cprintf("TEE\n");
    doLEDS(0,1,1);
  }
  else {
    cprintf("NONE\n");
    doLEDS(0,0,0);
  }

  delay(100);
}

void doLEDS(int red, int yell, int grn) {
  if(red == 1) digitalWrite(14,HIGH);
  else digitalWrite(14,LOW);
  if(yell == 1) digitalWrite(16,HIGH);
  else digitalWrite(16,LOW);
  if(grn == 1) digitalWrite(18,HIGH);
  else digitalWrite(18,LOW);  
}
