// ========================================================
// CBP_2403_D_LineFollower_2
// From FBO 20-08-21
// 19-08-23 
// Runs for a set time
// ========================================================

#include <CBPFBO_StepperA.h>

#define DEBUG false  

// This is the main Pixy object 
Pixy2 pixy;

float error;
float gain;

uint8_t x0;
uint8_t y0;
uint8_t x1;
uint8_t y1;

float degrees;
unsigned long startTime;

void setup(){
  Serial.begin(9600);                       
  gain = 1.0;  

  pixy.init();
  // Change to line tracking program
  pixy.changeProg("line");

  pixy.setLamp(1, 0);

  setRobotParams(49.9,100.0);

  startTime = millis();
}

void loop() {

  pixy.line.getAllFeatures();

  x0 = pixy.line.vectors[0].m_x0;
  y0 = pixy.line.vectors[0].m_y0;
  x1 = pixy.line.vectors[0].m_x1;
  y1 = pixy.line.vectors[0].m_y1;
  
  //cprintf("x0 = %2d, y0 = %2d, x1 = %2d, y1 = %2d",x0,y0,x1,y1);

  // Note unusual atan computation due to Pixy's coordinates
  degrees = (180/PI)*atan2((x1-x0),-(y1-y0));
  //cprintf(", degs = %f\n",degrees);

  error = gain*getErrorX();
  cprintf("error = %f\n",error); 
    if( (error > -0.95) && (error < 0.95)){
      moveABit(error, 0.80);
  } else {
    straightLine(100,18,false,true);
  }

  if(millis() - startTime > 20000){
    delay(2000);
    startTime = millis();
  }
    
}

float getErrorX() {
  float error;
  error = x0 - 40;
  error = -error / 40;
  return error; 
}
