// ====================================================
// CBP_FBO_Albus_Template.ino
// 28-11-23
// Template for Albus Severus 2403 DBT
// ====================================================

#include <AFMotor.h>

const int stepsPerRevolution = 200;

unsigned long delayVal;
unsigned long nrSteps = 0;


AF_Stepper motor1(stepsPerRevolution, 1);
AF_Stepper motor2(stepsPerRevolution, 2);

void setup() {
  Serial.begin(9600);
  Serial.println("Stepper test!");

  double wheelRad = 33;
  double circ = 2*PI*wheelRad;
  double dx = circ / 200.0; // 200 steps per rev for this stepper
  
  double distance = 200; //(mm)

  unsigned long nrStepsRequ = (unsigned long)(distance/dx);

  nrSteps = 0;

  double speedRequ =  0.5; // rpm
  delayVal = (unsigned long)(5000/speedRequ);
  
  while(nrSteps < nrStepsRequ) {

    int m1 = motor1.onestep(FORWARD, SINGLE); 
    int m2 = motor2.onestep(FORWARD, SINGLE); 
    delayMicroseconds(delayVal);

    nrSteps++;
  }
}

void loop() {


    
}
