// ======================================================
// Pixy2_2403_D_BeeEye
// 24-10-23
// Turns to then moves to detected object
// Based on:
// FBO_CBP_Calibrate_Camera.ino
// FB0 CBP 13-07021
// CBP Mod 14-07-21
// ======================================================

#include <Pixy2.h>
#include <Servo.h>

// Define pins --------------------------------
#define ServoL_pin 13
#define ServoR_pin 12

// Define constants ---------------------------
#define DEBUG true
#define wheelDiam 66.0
#define wheelRad (wheelDiam/2.0)
#define axleLen 104.0

// Global variables ---------------------------
Servo servoL;
Servo servoR; 

float driveL, driveR;
float error;
float maxDrive = 40;
float fwd = 10;

// This is the main Pixy object 
Pixy2 pixy;

// Pixy variables for this sketch -------------
uint16_t width;
uint16_t height;
uint16_t color;
uint8_t index;
uint16_t x;
uint16_t y;
float fieldWidth = 316.0;
float halfFieldWidth = 316.0/2.0;
int offset;

void setup() {  // ==== This runs once ========
  Serial.begin(9600);
  cprintf(">>> Initializing stuff ..................\n");
  Serial.print("Starting...\n");

  servoL.attach(ServoL_pin);
  servoR.attach(ServoR_pin);  

  // Init the camera
  pixy.init();

  cprintf(">>> Pausing 2 secs ......................\n");
  delay(2000);
  cprintf(">>> Starting  ...........................\n"); 

}

void loop() {

  // Now get a single block
  pixy.ccc.getBlocks(true,1,1);

  // Only do stuff if we have detected a block ------
  if (pixy.ccc.numBlocks > 0) {
    x = pixy.ccc.blocks[0].m_x;

    error = (float)(x - halfFieldWidth - 20);
    error = error / halfFieldWidth;  
    
    driveL = fwd + maxDrive * error;
    driveR = fwd - maxDrive * error;

    cprintf("x = %d, error = %f, driveL = %f, driveR = %f\n",x,error,driveL,driveR); 
    
    driveServos(driveL,driveR);
  }
  
}

void driveServos(float _driveL, float _driveR) {
  _driveR = _driveR*0.8;
  servoL.writeMicroseconds(1500 + (int)_driveL);
  servoR.writeMicroseconds(1500 - (int)_driveR);
}
