// ======================================================
// Pixy2_2403_R_FindGap
// 23-10-23
// Turns to then moves to detected object
// Based on:
// FBO_CBP_Calibrate_Camera.ino
// FB0 CBP 13-07021
// CBP Mod 14-07-21
// Status: Release
// ======================================================

#include <Pixy2.h>
#include <Servo.h>

// Define pins --------------------------------
#define ServoL_pin 13
#define ServoR_pin 12

// Define constants ---------------------------
#define DEBUG true
#define wheelDiam 66.0
#define wheelRad (wheelDiam/2.0)
#define axleLen 104.0

// Global variables ---------------------------
Servo servoL;
Servo servoR; 

float driveL, driveR;
float error;
float maxDrive = 40;
float fwd = 10;

// This is the main Pixy object 
Pixy2 pixy;

// Pixy variables for this sketch -------------
uint16_t width;
uint16_t height;
uint16_t color;
uint8_t index;
uint16_t x0;
uint16_t x1;
float xCentre;
float fieldWidth = 316.0;
float halfFieldWidth = 316.0/2.0;
int offset;

void setup() {  // ==== This runs once ========
  Serial.begin(9600);
  cprintf(">>> Initializing stuff ..................\n");

  servoL.attach(ServoL_pin);
  servoR.attach(ServoR_pin);  

  // Init the camera
  pixy.init();

  cprintf(">>> Pausing 2 secs ......................\n");
  delay(2000);
  cprintf(">>> Starting  ...........................\n"); 

}
void loop(){
  pixy.ccc.getBlocks(true,1,2);

  // Only do stuff if we have detected a block ------
  if (pixy.ccc.numBlocks > 0) {
    x0 = pixy.ccc.blocks[0].m_x;
    x1 = pixy.ccc.blocks[1].m_x;
	
	// Complete the following line to calc xCentre. Remember to
	// do float not int calculations
    xCentre =   

    // Complete the following line to calc erro. Remember to
	// do float not int calculations
    error = xCentre - (
    error = error / (float)halfFieldWidth; 
    
    cprintf("x0 = %d, x1 = %d, xCentre = %f, error = %f\n",x0,x1,xCentre,error);   

    driveL = fwd + maxDrive * error;
    driveR = fwd - maxDrive * error;
    
    driveServos(driveL,driveR);
  }
  
}

void loopy() {
  printf(".");
  // Now get up to 2 blocks
  //int nrBlocks = pixy.ccc.getBlocks(true,1,1);
  //printf("nrBlocks = %d\n",nrBlocks);

  pixy.ccc.getBlocks(true,1,1);
  
  // Only do stuff if we have detected a block ------
  if (pixy.ccc.numBlocks > 0) {
    x0 = pixy.ccc.blocks[0].m_x;
    //x1 = pixy.ccc.blocks[1].m_x;

     printf("x0 = %d\n",x0);
    //printf("x0 = %d, x1 = %d\n",x0,x1);
  //  error = (float)(x - halfFieldWidth);
  //  error = error / halfFieldWidth;  
    
   // driveL = fwd + maxDrive * error;
  //  driveR = fwd - maxDrive * error;

   // cprintf("x = %d, error = %f, driveL = %f, driveR = %f\n",x,error,driveL,driveR); 
    
   // driveServos(driveL,driveR);
  }
  
}

void driveServos(float _driveL, float _driveR) {
  _driveR = _driveR*0.8;
  servoL.writeMicroseconds(1500 + (int)_driveL);
  servoR.writeMicroseconds(1500 - (int)_driveR);
}
