// ========================================================
// Severus_Husky_LineFollower2
// CBP FBO 05-12-23
// from 3402_D_Husky_LineFollower 28-01-23
// uses moveABitNew(...)
// Sketch for exporing parameters
// ========================================================

#include "FBO_CBP_Stepper_B.h"
#include "HUSKYLENS.h"
#include "SoftwareSerial.h"

#define DEBUG true 

HUSKYLENS husky;

int x0;

FBO_CBP_Stepper_B Severus(200,1);

AF_Stepper motor1(200,1);
AF_Stepper motor2(200,2);

float dx = 2 * PI * 33 / 200;
float axleLen = 140;

void setup(){
  Serial.begin(9600); 

  Severus.setRobotParams(dx,axleLen);
  Severus.setRadMoveABit(250);
  Severus.setDistCameraAxle(180);
  Severus.setDeadBand(0.1);
  Severus.setGain(10.0);
  Severus.setSlowDown(1.5);
  
  Wire.begin();

  while( !husky.begin(Wire)){
    Serial.println("Check General Seetings >> Protocol Type >> I2C");
    Serial.println("Husky Configured");
    delay(100);
  }
  Serial.println("Husky Configured");
  husky.writeAlgorithm(ALGORITHM_LINE_TRACKING);

  cprintf("dx = %f\n",dx);
}


void loop() {

 if( !husky.request()) 
   cprintf("Recheck Connexions\n");
   
 if(husky.available()){
    HUSKYLENSResult result = husky.read();
    x0 = result.xOrigin;
    float error = getErrorX();
    Severus.moveABitNew(error,40, motor1, motor2);
    cprintf("Error = %f\n",error);
 }
                        
}

float getErrorX() {
  float error;
  error = (float)x0 - 160.0,
  error = error/160.0;
  return -error;
}
