// ===========================================================================
// FBP_CBP_Stepper_B.h
// 28-01-23
// Library for Albus_Severus robots using AF Motor Shield
// Mods 04-12-23
// ===========================================================================
#pragma once
#include "AFMotor.h"

// Removed from AF_Motor.h and redefined here to get correct direction
#define FORWARD  2
#define BACKWARD 1

class FBO_CBP_Stepper_B {
	
public:
	FBO_CBP_Stepper_B(uint16_t steps, uint8_t num);
	
	unsigned long ramp(int vMin, int vMax, unsigned long N, float alpha,
					   unsigned long n, bool upRamp, bool downRamp);

	void pivot(float degs, int vMin, int vMax,
			   bool upRamp, bool downRamp, AF_Stepper motorLeft, AF_Stepper motorRight);

	void arc(float R, float degs, int vMin, int vMax,
			 bool upRamp, bool downRamp, AF_Stepper motorLeft, AF_Stepper motorRight);

	void moveABit(float error, float deltaT, int vMin, int vMax,
				  AF_Stepper motorLeft, AF_Stepper motorRight);
				  
	void moveABitNew(float error, int vFwd, AF_Stepper motorLeft, AF_Stepper motorRight);


	void straightLine(int dist, int vMin, int vMax, 
                                     bool upRamp, bool downRamp,
									 AF_Stepper motorLeft, AF_Stepper motorRight);
									 
    void setDistCameraAxle(float _dist);

	void setRadMoveABit(float _rad);
	
	void setDeadBand(float _deadBand);
	
	void setRobotParams(float _dx, float _axleLength);
	
	void setGain(float _gain);
	
	void setSlowDown(float _slowdown); 
	
private:
	AF_Stepper* Stepper;
	// params for moveABit()
	float distCameraAxle;
	float radMoveABit;
	float deadBand;
	float gain;
	float slowdown;
	
	// GeneralParameters
	float dx;
	float axleLength;
	
};
